package go;

import go.lexer.Lexer;
import go.lexer.Lexer.State;
import go.node.*;

public class GoLexer extends Lexer {
        private Token last_token = null;

        public GoLexer(java.io.PushbackReader in) {
                super(in);
        }

        private boolean requires_semicolon() {
                return
		    (token instanceof TEol &&
		    (last_token instanceof TIdentifier
			|| last_token instanceof TInteger));
        }

        protected void filter() {
                if (requires_semicolon())
                        token = new TSemi();
                last_token = token;
        }
}
